# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from pf_driver/PFR2300Header.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import pf_driver.msg

class PFR2300Header(genpy.Message):
  _md5sum = "109593408f4e056fea70033a5665f604"
  _type = "pf_driver/PFR2300Header"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """pf_driver/PFHeader header

uint16 layer_index        # vertical layer index (0..3)
int32 layer_inclination   # vertical layer inclination [1/10000 degree]
uint64 timestamp_raw      # raw timestamp of first scan point in this packet in NTP time format
uint64 reserved1          # reserved - all bits zero for devices without switching I/Q
uint32 status_flags       # scan status flags (TODO: should this be a struct? or provide masking to extract
                                  # specific flags)
uint32 scan_frequency     # frequency of head rotation  (1/1000Hz)
uint16 num_points_scan    # number of scan points (samples) within complete scan
uint16 num_points_packet  # total number of scan points within this packet
uint16 first_index        # index of first scan point within this packet
int32 first_angle         # absolute angle of first scan point within this packet  (1/10000°)
int32 angular_increment   # delta between two succeding scan points (1/10000°) CCW rotation: +ve, CW
                                  # rotation: -ve
uint32 reserved2          # reserved - all bits zero for devices without switching I/Q
uint32 reserved3          # reserved - all bits zero for devices without switching I/Q
uint64 reserved4          # reserved - all bits zero for devices without switching I/Q
uint64 reserved5          # reserved - all bits zero for devices without switching I/Q
================================================================================
MSG: pf_driver/PFHeader
uint16 magic           # magic byte (0xa25c) marking the beginning of a packet
uint16 packet_type     # scan data packet type (0x0041 - 'A' 0x0042 - 'B' 0x0043 - 'C')
uint32 packet_size     # overall packet size in bytes (header + payload)
uint16 header_size     # header size in bytes (offset to payload data)
uint16 scan_number     # sequence number for scan (incremented for every scan, starting with 0, overflows)
uint16 packet_number   # sequence number for packet (counting packets of a particular scan, starting with 1)"""
  __slots__ = ['header','layer_index','layer_inclination','timestamp_raw','reserved1','status_flags','scan_frequency','num_points_scan','num_points_packet','first_index','first_angle','angular_increment','reserved2','reserved3','reserved4','reserved5']
  _slot_types = ['pf_driver/PFHeader','uint16','int32','uint64','uint64','uint32','uint32','uint16','uint16','uint16','int32','int32','uint32','uint32','uint64','uint64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,layer_index,layer_inclination,timestamp_raw,reserved1,status_flags,scan_frequency,num_points_scan,num_points_packet,first_index,first_angle,angular_increment,reserved2,reserved3,reserved4,reserved5

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PFR2300Header, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = pf_driver.msg.PFHeader()
      if self.layer_index is None:
        self.layer_index = 0
      if self.layer_inclination is None:
        self.layer_inclination = 0
      if self.timestamp_raw is None:
        self.timestamp_raw = 0
      if self.reserved1 is None:
        self.reserved1 = 0
      if self.status_flags is None:
        self.status_flags = 0
      if self.scan_frequency is None:
        self.scan_frequency = 0
      if self.num_points_scan is None:
        self.num_points_scan = 0
      if self.num_points_packet is None:
        self.num_points_packet = 0
      if self.first_index is None:
        self.first_index = 0
      if self.first_angle is None:
        self.first_angle = 0
      if self.angular_increment is None:
        self.angular_increment = 0
      if self.reserved2 is None:
        self.reserved2 = 0
      if self.reserved3 is None:
        self.reserved3 = 0
      if self.reserved4 is None:
        self.reserved4 = 0
      if self.reserved5 is None:
        self.reserved5 = 0
    else:
      self.header = pf_driver.msg.PFHeader()
      self.layer_index = 0
      self.layer_inclination = 0
      self.timestamp_raw = 0
      self.reserved1 = 0
      self.status_flags = 0
      self.scan_frequency = 0
      self.num_points_scan = 0
      self.num_points_packet = 0
      self.first_index = 0
      self.first_angle = 0
      self.angular_increment = 0
      self.reserved2 = 0
      self.reserved3 = 0
      self.reserved4 = 0
      self.reserved5 = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2HI4Hi2Q2I3H2i2I2Q().pack(_x.header.magic, _x.header.packet_type, _x.header.packet_size, _x.header.header_size, _x.header.scan_number, _x.header.packet_number, _x.layer_index, _x.layer_inclination, _x.timestamp_raw, _x.reserved1, _x.status_flags, _x.scan_frequency, _x.num_points_scan, _x.num_points_packet, _x.first_index, _x.first_angle, _x.angular_increment, _x.reserved2, _x.reserved3, _x.reserved4, _x.reserved5))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = pf_driver.msg.PFHeader()
      end = 0
      _x = self
      start = end
      end += 82
      (_x.header.magic, _x.header.packet_type, _x.header.packet_size, _x.header.header_size, _x.header.scan_number, _x.header.packet_number, _x.layer_index, _x.layer_inclination, _x.timestamp_raw, _x.reserved1, _x.status_flags, _x.scan_frequency, _x.num_points_scan, _x.num_points_packet, _x.first_index, _x.first_angle, _x.angular_increment, _x.reserved2, _x.reserved3, _x.reserved4, _x.reserved5,) = _get_struct_2HI4Hi2Q2I3H2i2I2Q().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2HI4Hi2Q2I3H2i2I2Q().pack(_x.header.magic, _x.header.packet_type, _x.header.packet_size, _x.header.header_size, _x.header.scan_number, _x.header.packet_number, _x.layer_index, _x.layer_inclination, _x.timestamp_raw, _x.reserved1, _x.status_flags, _x.scan_frequency, _x.num_points_scan, _x.num_points_packet, _x.first_index, _x.first_angle, _x.angular_increment, _x.reserved2, _x.reserved3, _x.reserved4, _x.reserved5))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = pf_driver.msg.PFHeader()
      end = 0
      _x = self
      start = end
      end += 82
      (_x.header.magic, _x.header.packet_type, _x.header.packet_size, _x.header.header_size, _x.header.scan_number, _x.header.packet_number, _x.layer_index, _x.layer_inclination, _x.timestamp_raw, _x.reserved1, _x.status_flags, _x.scan_frequency, _x.num_points_scan, _x.num_points_packet, _x.first_index, _x.first_angle, _x.angular_increment, _x.reserved2, _x.reserved3, _x.reserved4, _x.reserved5,) = _get_struct_2HI4Hi2Q2I3H2i2I2Q().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2HI4Hi2Q2I3H2i2I2Q = None
def _get_struct_2HI4Hi2Q2I3H2i2I2Q():
    global _struct_2HI4Hi2Q2I3H2i2I2Q
    if _struct_2HI4Hi2Q2I3H2i2I2Q is None:
        _struct_2HI4Hi2Q2I3H2i2I2Q = struct.Struct("<2HI4Hi2Q2I3H2i2I2Q")
    return _struct_2HI4Hi2Q2I3H2i2I2Q
